/* the gmp3 project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/gmp3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include "support.h"
#include "public.h"
#include "configfile.h"

int
options_save (void)
{
	gchar *my_options[200][2]={
	/* Tab "Preferences" */
		{ "check_options_preferences_splash", "NO_SPLASH" },
	/* Tab "FreeDB" */
		{ "clist_options_freedb_server", "FREEDB_SERVER" },
		{ "check_options_freedb_proxy", "FREEDB_PROXY_ENABLE" },
		{ "entry_options_freedb_proxy", "FREEDB_PROXY" },
		{ "entry_options_freedb_proxy_port", "FREEDB_PROXY_PORT" },
		{ "entry_options_freedb_path_local", "FREEDB_PATH" },
		{ "\0", "\0" }
	};
	
	extern GtkWidget *options;
	FILE *configfile = NULL;
	Stack options_config;
	gchar *config[2048][2];
	gint i=-1, f=0, buf;
	gchar *foo[4];
	
	for(buf=0; buf!=4; buf++) foo[buf]=NULL;
	mem_init(&options_config);
	
	while(my_options[++i][0])
	{
		if(!strncmp(my_options[i][0], "check", 5))
		{
			config[f][0] = mem_allocate(&options_config);
			config[f][1] = mem_allocate(&options_config);
			strcpy(config[f][0], my_options[i][1]);
			if( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(lookup_widget(options, my_options[i][0]))) )
				sprintf(config[f][1], "TRUE");
			else
				sprintf(config[f][1], "FALSE");
			++f;
		}
		else if(!strncmp(my_options[i][0], "entry", 5))
		{
			config[f][0] = mem_allocate(&options_config);
			config[f][1] = mem_allocate(&options_config);
			strcpy(config[f][0], my_options[i][1]);
			strcpy(config[f][1], gtk_entry_get_text(GTK_ENTRY(lookup_widget(options, my_options[i][0]))));
			++f;
		}
		else if(!strncmp(my_options[i][0], "clist", 5))
		{
			buf=-1;
			while(gtk_clist_get_text(GTK_CLIST(lookup_widget(options, my_options[i][0])), ++buf, 2, &foo[2]))
			{
				config[f][0] = mem_allocate(&options_config);
				config[f][1] = mem_allocate(&options_config);
				gtk_clist_get_text(GTK_CLIST(lookup_widget(options, my_options[i][0])), buf, 0, &foo[0]);
				gtk_clist_get_text(GTK_CLIST(lookup_widget(options, my_options[i][0])), buf, 1, &foo[1]);
				gtk_clist_get_text(GTK_CLIST(lookup_widget(options, my_options[i][0])), buf, 3, &foo[3]);

				sprintf(config[f][0], "%s", my_options[i][1]);
				sprintf(config[f][1], "%s,%s,%s,%s", foo[0], foo[1], foo[2], foo[3]);
				
				++f;
			}
		}
		config[f+1][0] = NULL;
		config[f+1][1] = NULL;
	}
	
// Put to configfile
	configfile = fopen(foo[0]=g_strconcat(getenv("HOME"), "/.gmp3rc", '\0'), "wb");
	if (!configfile) return -1;
	free(foo[0]);
		
	i=-1;
	while(config[++i][0])
	{
		if(*config[i][1]!='\0')
			fprintf(configfile, "%s=%s\n", config[i][0], config[i][1]);
	}
	fclose(configfile);

	mem_free(&options_config);
	return 0;
}






int
options_load (void)
{
	gchar *my_options[200][2]={
	/* Tab "Preferences" */
		{ "check_options_preferences_splash", "NO_SPLASH" },
	/* Tab "FreeDB" */
		{ "clist_options_freedb_server", "FREEDB_SERVER" },
		{ "check_options_freedb_proxy", "FREEDB_PROXY_ENABLE" },
		{ "entry_options_freedb_proxy", "FREEDB_PROXY" },
		{ "entry_options_freedb_proxy_port", "FREEDB_PROXY_PORT" },
		{ "entry_options_freedb_path_local", "FREEDB_PATH" },
		{ "\0", "\0" }
	};
	
	extern GtkWidget *options;
	extern Stack clist_options_data;
	Stack options_config;
	FILE *configfile = NULL;
	gint i=-1, f=0;
	gchar option_in[200];
	gchar value_in[2000];
	gchar *config[2048][2];
	gchar *foo[4];
	
// Get from configfile
	configfile = fopen(foo[0]=g_strconcat(getenv("HOME"), "/.gmp3rc", '\0'), "rb");
	if (!configfile) return -1;
	free(foo[0]);
	
	mem_free(&clist_options_data);
	mem_init(&clist_options_data);
	mem_init(&options_config);
	memset(option_in, 0, 200);
	fscanf(configfile, "%s\n", option_in);
	while(*option_in!='\0')
	{
		sprintf(value_in, "%s", strchr(option_in, '=')+1);
		*strchr(option_in, '=')='\0';
		i=-1;
		while(*my_options[++i][0]!='\0')
		{
			config[f+1][0] = NULL;
			config[f+1][1] = NULL;
			if(!strcmp(my_options[i][1], option_in))
			{
				config[f][0] = mem_allocate(&options_config);
				config[f][1] = mem_allocate(&options_config);
				strcpy(config[f][0], my_options[i][0]);
				strcpy(config[f][1], value_in);
				config[f+1][0] = NULL;
				config[f+1][1] = NULL;
				++f;
				break;
			}
		}
		memset(option_in, 0, 200);
		fscanf(configfile, "%s\n", option_in);
	}
	fclose(configfile);


	i=-1;
	while(config[++i][0])
	{
		if(!strncmp(config[i][0], "check", 5))
		{
			if( !strncmp(config[i][1], "TRUE", 4) )
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(options, config[i][0])), TRUE);
			else
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(options, config[i][0])), FALSE);
		}
		else if(!strncmp(config[i][0], "entry", 5))
		{
			foo[0] = mem_allocate(&clist_options_data);
			strcpy(foo[0], config[i][1]);
			gtk_entry_set_text(GTK_ENTRY(lookup_widget(options, config[i][0])), foo[0]);
		}
		else if(!strncmp(config[i][0], "clist", 5))
		{
			foo[0] = mem_allocate(&clist_options_data);
			foo[1] = mem_allocate(&clist_options_data);
			foo[2] = mem_allocate(&clist_options_data);
			foo[3] = mem_allocate(&clist_options_data);
			strcpy(foo[3], strrchr(config[i][1], ',')+1);
			*strrchr(config[i][1], ',')='\0';
			strcpy(foo[2], strrchr(config[i][1], ',')+1);
			*strrchr(config[i][1], ',')='\0';
			strcpy(foo[1], strrchr(config[i][1], ',')+1);
			*strrchr(config[i][1], ',')='\0';
			strcpy(foo[0], config[i][1]);
			gtk_clist_append(GTK_CLIST(lookup_widget(options, config[i][0])), foo);
			gtk_clist_columns_autosize(GTK_CLIST(lookup_widget(options, config[i][0])));
		}
	}

	mem_free(&options_config);
	return 0;
}









int
rules_save (void)
{
	gchar *my_options[200][2]={
// Tab "Tagging rules"
		{ "check_rules_tag_get", "RULE_TAG_GET_ENABLE" },
		{ "entry_rules_tag_get", "RULE_TAG_GET_FORMAT" },

		{ "check_rules_tag_cleanup", "RULE_TAG_CLEANUP_ENABLE" },

		{ "check_rules_tag_v2tov1", "RULE_TAG_V2toV1_ENABLE" },
		{ "check_rules_tag_v1tov2", "RULE_TAG_V1toV2_ENABLE" },
		
		{ "check_rules_tag_deleteid3v1", "RULE_TAG_V1DELETE_ENABLE" },
		{ "check_rules_tag_deleteid3v2", "RULE_TAG_V2DELETE_ENABLE" },
		
// Tab "General rules"
		{ "check_rules_replace", "RULE_REPLACE_ENABLE" },
		{ "entry_rules_replace_from", "RULE_REPLACE_FROM" },
		{ "entry_rules_replace_to", "RULE_REPLACE_TO" },

		{ "check_rules_format", "RULE_FORMAT_ENABLE" },
		{ "entry_rules_fromformat", "RULE_FORMAT_FROM" },
		{ "entry_rules_toformat", "RULE_FORMAT_TO" },

		{ "check_rules_remove", "RULE_REMOVE_ENABLE" },
		{ "option_rules_remove_leading", "RULE_REMOVE_WHAT" },
		
		{ "check_rules_forcecc", "RULE_FORCECC_ENABLE" },
		{ "option_rules_forcecc_case", "RULE_FORCECC_CASE" },
		
		{ "check_rules_deletechar", "RULE_DELETECHAR_ENABLE" },
		{ "spin_rules_deletechar_from", "RULE_DELETECHAR_FROM" },
		{ "spin_rules_deletechar_to", "RULE_DELETECHAR_TO" },

		{ "check_rules_increase", "RULE_INCREASE_ENABLE" },
		{ "spin_rules_increase_by", "RULE_INCREASE_BY" },
		
		{ "check_rules_killspace", "RULE_KILLSPACE_ENABLE" },
		{ "option_rules_killspace", "RULE_KILLSPACE_AT" },
		
		{ "check_rules_stripchar", "RULE_STRIPCHAR_ENABLE" },
		{ "check_rules_twodigit", "RULE_TWODIGIT_ENABLE" },
		{ "check_rules_insertspace", "RULE_INSERTSPACE_ENABLE" },
		{ "check_rules_stripspace", "RULE_STRIPSPACE_ENABLE" },
		
		{ "clist_rules_rules", "RULE_RULE" },
		{ "\0", "\0" }
	};
	
	extern GtkWidget *rules;
	FILE *configfile = NULL;
	Stack rules_config;
	gchar *config[2048][2];
	gint i=-1, f=0, buf;
	gchar *foo[4];
	
	for(buf=0; buf!=4; buf++) foo[buf]=NULL;
	mem_init(&rules_config);
	
	while(*my_options[++i][0]!='\0')
	{
		if(!strncmp(my_options[i][0], "check", 5))
		{
			config[f][0] = mem_allocate(&rules_config);
			config[f][1] = mem_allocate(&rules_config);
			strcpy(config[f][0], my_options[i][1]);
			if( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(lookup_widget(rules, my_options[i][0]))) )
				sprintf(config[f][1], "TRUE");
			else
				sprintf(config[f][1], "FALSE");
			++f;
		}
		else if(!strncmp(my_options[i][0], "entry", 5))
		{
			config[f][0] = mem_allocate(&rules_config);
			config[f][1] = mem_allocate(&rules_config);
			strcpy(config[f][0], my_options[i][1]);
			strcpy(config[f][1], gtk_entry_get_text(GTK_ENTRY(lookup_widget(rules, my_options[i][0]))));
			++f;
		}
		else if(!strncmp(my_options[i][0], "spin", 4))
		{
			config[f][0] = mem_allocate(&rules_config);
			config[f][1] = mem_allocate(&rules_config);
			strcpy(config[f][0], my_options[i][1]);
			sprintf(config[f][1], "%i", gtk_spin_button_get_value_as_int(
								GTK_SPIN_BUTTON(lookup_widget(rules, my_options[i][0]))));
			++f;
		}
		else if(!strncmp(my_options[i][0], "option", 6))
		{
			config[f][0] = mem_allocate(&rules_config);
			config[f][1] = mem_allocate(&rules_config);
			gtk_label_get(GTK_LABEL(GTK_BIN(lookup_widget(rules, my_options[i][0]))->child), &foo[0]);
			strcpy(config[f][0], my_options[i][1]);
			strcpy(config[f][1], foo[0]);
			++f;
		}
		else if(!strncmp(my_options[i][0], "clist", 5))
		{
			buf=-1;
			while(gtk_clist_get_text(GTK_CLIST(lookup_widget(rules, my_options[i][0])), ++buf, 0, &foo[0]))
			{
				config[f][0] = mem_allocate(&rules_config);
				config[f][1] = mem_allocate(&rules_config);
				sprintf(config[f][0], "%s", my_options[i][1]);
				sprintf(config[f][1], "%s", foo[0]);
				
				f++;
				config[f][0] = mem_allocate(&rules_config);
				config[f][1] = mem_allocate(&rules_config);
				sprintf(config[f][0], "%s", my_options[i][1]);
				sprintf(config[f][1], "%s,%s,%s",
					(char *)gtk_clist_get_row_data(GTK_CLIST(lookup_widget(rules, my_options[i][0])), buf),
					strrchr((char *)gtk_clist_get_row_data(GTK_CLIST(lookup_widget(rules, my_options[i][0])), buf), '\0')+1,
					strrchr(strrchr((char *)gtk_clist_get_row_data(GTK_CLIST(lookup_widget(rules, my_options[i][0])), buf), '\0')+1, '\0')+1);
				
				f++;
			}
		}
		config[f+1][0] = NULL;
		config[f+1][1] = NULL;
	}

// Put to configfile
	configfile = fopen(foo[0]=g_strconcat(getenv("HOME"), "/.gmp3rules", '\0'), "wb");
	free(foo[0]);
	if (!configfile) return -1;
		
	i=-1;
	while(config[++i][0])
	{
		if(config[i][1])
			fprintf(configfile, "%s=%s\n", config[i][0], config[i][1]);
	}
	fclose(configfile);

	mem_free(&rules_config);
	return 0;
}





int
rules_load (void)
{
	gchar *my_options[200][2]={
// Tab "Tagging rules"
		{ "check_rules_tag_get", "RULE_TAG_GET_ENABLE" },
		{ "entry_rules_tag_get", "RULE_TAG_GET_FORMAT" },

		{ "check_rules_tag_cleanup", "RULE_TAG_CLEANUP_ENABLE" },

		{ "check_rules_tag_v2tov1", "RULE_TAG_V2toV1_ENABLE" },
		{ "check_rules_tag_v1tov2", "RULE_TAG_V1toV2_ENABLE" },
		
		{ "check_rules_tag_deleteid3v1", "RULE_TAG_V1DELETE_ENABLE" },
		{ "check_rules_tag_deleteid3v2", "RULE_TAG_V2DELETE_ENABLE" },
		
// Tab "General rules"
		{ "check_rules_replace", "RULE_REPLACE_ENABLE" },
		{ "entry_rules_replace_from", "RULE_REPLACE_FROM" },
		{ "entry_rules_replace_to", "RULE_REPLACE_TO" },

		{ "check_rules_format", "RULE_FORMAT_ENABLE" },
		{ "entry_rules_fromformat", "RULE_FORMAT_FROM" },
		{ "entry_rules_toformat", "RULE_FORMAT_TO" },

		{ "check_rules_remove", "RULE_REMOVE_ENABLE" },
		{ "option_rules_remove_leading", "RULE_REMOVE_WHAT" },
		
		{ "check_rules_forcecc", "RULE_FORCECC_ENABLE" },
		{ "option_rules_forcecc_case", "RULE_FORCECC_CASE" },
		
		{ "check_rules_deletechar", "RULE_DELETECHAR_ENABLE" },
		{ "spin_rules_deletechar_from", "RULE_DELETECHAR_FROM" },
		{ "spin_rules_deletechar_to", "RULE_DELETECHAR_TO" },

		{ "check_rules_increase", "RULE_INCREASE_ENABLE" },
		{ "spin_rules_increase_by", "RULE_INCREASE_BY" },
		
		{ "check_rules_killspace", "RULE_KILLSPACE_ENABLE" },
		{ "option_rules_killspace", "RULE_KILLSPACE_AT" },
		
		{ "check_rules_stripchar", "RULE_STRIPCHAR_ENABLE" },
		{ "check_rules_twodigit", "RULE_TWODIGIT_ENABLE" },
		{ "check_rules_insertspace", "RULE_INSERTSPACE_ENABLE" },
		{ "check_rules_stripspace", "RULE_STRIPSPACE_ENABLE" },
		
		{ "clist_rules_rules", "RULE_RULE" },
		{ "\0", "\0" }
	};
	
	extern GtkWidget *rules;
	extern Stack clist_rules_data;
	Stack rules_config;
	FILE *configfile = NULL;
	gint i=-1, f=0;
	gchar *option_in = calloc(200, sizeof(gchar));
	gchar value_in[2000];
	gchar *config[2048][2];
	gchar *foo[4];
	
// Get from configfile
	configfile = fopen(foo[0]=g_strconcat(getenv("HOME"), "/.gmp3rules", '\0'), "rb");
	free(foo[0]);
	if (!configfile) return -1;
	
	mem_free(&clist_rules_data);
	mem_init(&clist_rules_data);
	mem_init(&rules_config);
// read first line from file
	i=-1;
	while(fread(option_in+(++i), 1, 1, configfile))
	{
		if(*(option_in+i)==0
			|| *(option_in+i)=='\n')
		{
			*(option_in+i)=0;
			break;
		}
	}
// parse through the entire file
	while(*option_in!='\0')
	{
// split the line up into two pieces (option and value)
		sprintf(value_in, "%s", strchr(option_in, '=')+1);
		*strchr(option_in, '=')='\0';
// find the options destination widget
		i=-1;
		while(*my_options[++i][0]!='\0')
		{
			if(!strcmp(my_options[i][1], option_in))
			{
				config[f][0] = mem_allocate(&rules_config);
				config[f][1] = mem_allocate(&rules_config);
				strcpy(config[f][0], my_options[i][0]);
				strcpy(config[f][1], value_in);
				config[f+1][0] = NULL;
				config[f+1][1] = NULL;
				++f;
				break;
			}
		}
// Get next line out of file
		memset(option_in, 0, 200);
		i=-1;
		while(fread(option_in+(++i), 1, 1, configfile))
		{
			if(*(option_in+i)==0
				|| *(option_in+i)=='\n')
			{
				*(option_in+i)=0;
				break;
			}
		}
	}
	fclose(configfile);

	i=-1;
	while(config[++i][0])
	{
		if(!strncmp(config[i][0], "check", 5))
		{
			if( !strncmp(config[i][1], "TRUE", 4) )
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(rules, config[i][0])), TRUE);
			else
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget(rules, config[i][0])), FALSE);
		}
		else if(!strncmp(config[i][0], "entry", 5))
		{
			foo[0] = mem_allocate(&clist_rules_data);
			strcpy(foo[0], config[i][1]);
			gtk_entry_set_text(GTK_ENTRY(lookup_widget(rules, config[i][0])), foo[0]);
		}
		else if(!strncmp(config[i][0], "clist", 5))
		{
			foo[0] = mem_allocate(&clist_rules_data);
			sprintf(foo[0], "%s", config[i][1]);
			
			foo[1] = mem_allocate(&clist_rules_data);
			*strrchr(config[++i][1], ',')='\0';
			*strrchr(config[i][1], ',')='\0';
			sprintf(foo[1], "%s%c%s%c%s",
				config[i][1], '\0',
				strrchr(config[i][1], '\0') + 1, '\0',
				strrchr(strrchr(config[i][1], '\0') + 1, '\0') + 1);
			
			gtk_clist_set_row_data(GTK_CLIST(lookup_widget(rules, config[i][0])),
				gtk_clist_append(GTK_CLIST(lookup_widget(rules, config[i][0])), foo),
				foo[1]);
		}
	}

	mem_free(&rules_config);
	free(option_in);
	return 0;
}












/*
 * This function will grab the value of one option out of the configfile
 */
gboolean
option_get (const gchar *option, gchar *value)
{
	FILE *configfile = NULL;
	gchar option_in[2000];
	gchar value_in[2000];
	gchar *foo;
	
// Get from configfile
	configfile = fopen(foo=g_strconcat(getenv("HOME"), "/.gmp3rc", '\0'), "rb");
	if (!configfile) return FALSE;
	free(foo);
	
	memset(option_in, 0, 2000);
	while(fscanf(configfile, "%s\n", option_in)>0)
	{
		sprintf(value_in, "%s", strchr(option_in, '=')+1);
		*strchr(option_in, '=')='\0';
		if(!strcmp(option_in, option))
		{
			fclose(configfile);
			strcpy(value, value_in);
			return TRUE;
		}
		memset(option_in, 0, 2000);
	}
	return FALSE;
}
