/* the gmp3 project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/gmp3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include "support.h"
#include "public.h"
#include "dialog_options.h"

void
options_freedb_server_add(void)
{
	extern GtkWidget *options;
	extern Stack clist_options_data;
	gchar *rowdata;
	gchar *row[4];
	
	rowdata = mem_allocate(&clist_options_data);
	
	row[0] = calloc(2000,sizeof(gchar));
	strcpy(row[0], gtk_entry_get_text(GTK_ENTRY(lookup_widget(options, "entry_options_freedb_server"))));
	
	row[1] = calloc(2000,sizeof(gchar));
	strcpy(row[1], gtk_entry_get_text(GTK_ENTRY(lookup_widget(options, "entry_options_freedb_port"))));

	row[2] = calloc(2000,sizeof(gchar));
	row[3] = calloc(2000,sizeof(gchar));
	if(!GTK_WIDGET_IS_SENSITIVE(lookup_widget(options, "entry_options_freedb_path")))
	{
		strcpy(row[2], "FREEDB");
		*row[3]='\0';
	}
	else
	{
		strcpy(row[2], "HTTP");
		strcpy(row[3], gtk_entry_get_text(GTK_ENTRY(lookup_widget(options, "entry_options_freedb_path"))));
	}
	
	gtk_clist_append(GTK_CLIST(lookup_widget(options, "clist_options_freedb_server")), row);
}








void
options_freedb_server_delete(void)
{
	extern GtkWidget *options;
	GtkCList *clist_options_freedb_server;
	GList *selection;
	gint row;

	clist_options_freedb_server = GTK_CLIST (lookup_widget (options, _("clist_options_freedb_server")));

	selection = clist_options_freedb_server->selection;

	while (selection)
	{
		row = (gint)selection->data;
		selection = selection->next;
		gtk_clist_remove(clist_options_freedb_server, row);
	}
}



/*
 ***************************************************************************
 * this will move all selected servers up one row (=increase its priority).
 ***************************************************************************
 */
void dialog_options_freedb_server_up(void)
{
	extern GtkWidget *options;
	GtkCList *clist_options_freedb_server;
	GList *selection;
	gchar *foo;
	gint row=0;
	gint max=-1;
	gboolean stopit=FALSE;

	clist_options_freedb_server = GTK_CLIST (lookup_widget (options, _("clist_options_freedb_server")));
	
	while(gtk_clist_get_text (clist_options_freedb_server, ++max, 0, &foo));

	while (row < max)
	{
		selection = clist_options_freedb_server->selection;
		while (selection)
		{
			if((gint)selection->data==row)
			{
				if(gtk_clist_get_text (clist_options_freedb_server, row-1, 0, &foo))
					gtk_clist_swap_rows (clist_options_freedb_server, row, row-1);
				else
					stopit=TRUE;
				break;
			}
			selection = selection->next;
		}
		if(stopit) break;
		++row;
	}
}




/*
 ***************************************************************************
 * this will move all selected servers down one row (=decrease its priority).
 ***************************************************************************
 */
void dialog_options_freedb_server_down(void)
{
	extern GtkWidget *options;
	GtkCList *clist_options_freedb_server;
	GList *selection;
	gchar *foo;
	gint row=-1;
	gboolean stopit=FALSE;

	clist_options_freedb_server = GTK_CLIST (lookup_widget (options, _("clist_options_freedb_server")));
	
	while(gtk_clist_get_text (clist_options_freedb_server, ++row, 0, &foo));

	while (row >= 0)
	{
		selection = clist_options_freedb_server->selection;
		while (selection)
		{
			if((gint)selection->data==row)
			{
				if(gtk_clist_get_text (clist_options_freedb_server, row+1, 0, &foo))
					gtk_clist_swap_rows (clist_options_freedb_server, row, row+1);
				else
					stopit=TRUE;
				break;
			}
			selection = selection->next;
		}
		if(stopit) break;
		--row;
	}
}
