/* the gmp3 project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/gmp3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include "dialog_rules.h"
#include "support.h"
#include "public.h"
#include "gui.h"

// this will copy the actual filterlist to the filterlist in the mainwindow and then close the filterwindow.
void dialog_rules_close(void)
{
	extern GtkWidget *gmp3;
	extern GtkWidget *rules;
	
	GtkCList *clist_gmp3_rules;
	GtkCList *clist_rules_rules;
	
	gchar *output[1];
	gint row=-1;

	clist_gmp3_rules = GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_rules")));
	clist_rules_rules = GTK_CLIST (lookup_widget (rules, _("clist_rules_rules")));

	gtk_clist_clear(clist_gmp3_rules);

	while (gtk_clist_get_text (clist_rules_rules, ++row, 0, &output[0]))
	{
		gtk_clist_set_row_data(clist_gmp3_rules,
			gtk_clist_append (clist_gmp3_rules, output),
			gtk_clist_get_row_data (clist_rules_rules, row) );
	}

	gtk_widget_hide(rules);
	gtk_widget_destroy(rules);
}



// this will copy the filterlist of mainwindow to the filterlist in the filtereditor and then open the filterwindow
void dialog_rules_create(void)
{
	extern GtkWidget *gmp3;
	extern GtkWidget *rules;
	
	GtkCList *clist_gmp3_rules;
	GtkCList *clist_rules_rules;
	
	gchar *output[1];
	gint row=-1;

	rules = create_rules();
	
	clist_gmp3_rules = GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_rules")));
	clist_rules_rules = GTK_CLIST (lookup_widget (rules, _("clist_rules_rules")));

	while (gtk_clist_get_text (clist_gmp3_rules, ++row, 0, &output[0]))
	{
		gtk_clist_set_row_data(clist_rules_rules,
			gtk_clist_append (clist_rules_rules, output),
			gtk_clist_get_row_data (clist_gmp3_rules, row) );
	}

	gtk_widget_show(rules);
}



// this will empty out the actual filterlist.
void dialog_rules_clear(void)
{
	extern GtkWidget *rules;
	extern Stack clist_rules_data;
	
	GtkCList *clist_rules_rules;

	clist_rules_rules = GTK_CLIST (lookup_widget (rules, _("clist_rules_rules")));
// clear filterlist
	gtk_clist_clear(clist_rules_rules);
	mem_free(&clist_rules_data);
}



// this will set all togglebuttons to not pressed.
void dialog_rules_init(void)
{
	extern GtkWidget *rules;
	
// tab "general options"
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_replace"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_format"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_remove"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_forcecc"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_deletechar"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_increase"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_stripchar"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_insertspace"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_twodigit"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_stripspace"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_killspace"))),FALSE);

// tab "tagging options"
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_tag_get"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_tag_cleanup"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_tag_v1tov2"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_tag_v2tov1"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_tag_deleteid3v1"))),FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_tag_deleteid3v2"))),FALSE);
}



/*
 ***************************************************************************
 * this will move all selected rules up one row (=increase its priority).
 ***************************************************************************
 */
void dialog_rules_up(void)
{
	extern GtkWidget *rules;
	GtkCList *clist_rules_rules;
	GList *selection;
	gchar *foo;
	gint row=0;
	gint max=-1;
	gboolean stopit=FALSE;

	clist_rules_rules = GTK_CLIST (lookup_widget (rules, _("clist_rules_rules")));
	
	while(gtk_clist_get_text (clist_rules_rules, ++max, 0, &foo));

	while (row < max)
	{
		selection = clist_rules_rules->selection;
		while (selection)
		{
			if((gint)selection->data==row)
			{
				if(gtk_clist_get_text (clist_rules_rules, row-1, 0, &foo))
					gtk_clist_swap_rows (clist_rules_rules, row, row-1);
				else
					stopit=TRUE;
				break;
			}
			selection = selection->next;
		}
		if(stopit) break;
		++row;
	}
}



/*
 ***************************************************************************
 * this will remove all selected rules from filterlist.
 ***************************************************************************
 */
void dialog_rules_delete(void)
{
	extern GtkWidget *rules;
	GtkCList *clist_rules_rules;
	GList *selection;
	gint row;

	clist_rules_rules = GTK_CLIST (lookup_widget (rules, _("clist_rules_rules")));

	selection = clist_rules_rules->selection;

	while (selection)
	{
		row = (gint)selection->data;
		selection = selection->next;
		gtk_clist_remove(clist_rules_rules, row);
	}
}



/*
 ***************************************************************************
 * this will move all selected rules down one row (=decrease its priority).
 ***************************************************************************
 */
void dialog_rules_down(void)
{
	extern GtkWidget *rules;
	GtkCList *clist_rules_rules;
	GList *selection;
	gchar *foo;
	gint row=-1;
	gboolean stopit=FALSE;

	clist_rules_rules = GTK_CLIST (lookup_widget (rules, _("clist_rules_rules")));
	
	while(gtk_clist_get_text (clist_rules_rules, ++row, 0, &foo));

	while (row >= 0)
	{
		selection = clist_rules_rules->selection;
		while (selection)
		{
			if((gint)selection->data==row)
			{
				if(gtk_clist_get_text (clist_rules_rules, row+1, 0, &foo))
					gtk_clist_swap_rows (clist_rules_rules, row, row+1);
				else
					stopit=TRUE;
				break;
			}
			selection = selection->next;
		}
		if(stopit) break;
		--row;
	}
}



/*
 ***************************************************************************
 * this will add new created rules to the filter list.
 ***************************************************************************
 */
void dialog_rules_add(void)
{
	extern GtkWidget *rules;
	extern Stack clist_rules_data;
	gchar *output[1];
	gchar *filtername, *option1, *option2, *foo, *rowdata;

	output[0] = mem_allocate(&clist_rules_data);
	filtername = calloc(1000,sizeof(gchar));
	option1 = calloc(1000,sizeof(gchar));
	option2 = calloc(1000,sizeof(gchar));

// ADD FILTER: Copy ID3V1 tag to V2 tag.
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_tag_v1tov2")))))
	{
		sprintf(output[0], "- If present, copy the contents of an ID3V1 tag to an ID3V2 tag.");

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "v1tov2");
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Copy ID3V2 tag to V1 tag.
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_tag_v2tov1")))))
	{
		sprintf(output[0], "- If present, copy the contents of an ID3V2 tag to an ID3V1 tag.");

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "v2tov1");
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Delete ID3V1 tag
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_tag_deleteid3v1")))))
	{
		sprintf(output[0], "- Delete the ID3V1 tag.");

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "v1delete");
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Delete ID3V2 tag
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_tag_deleteid3v2")))))
	{
		sprintf(output[0], "- Delete the ID3V2 tag.");

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "v2delete");
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Cleanup ID3V1 tag (=padding spaces to NULL).
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_tag_cleanup")))))
	{
		sprintf(output[0], "- Cleanup buggy ID3V1 tags.");

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "tagcleanup");
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Get data out of tag.
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_tag_get")))))
	{
		sprintf(filtername, "Get data from tag");
		sprintf(option1, "%s", gtk_entry_get_text (GTK_ENTRY(lookup_widget(rules,("entry_rules_tag_get")))));

		sprintf(output[0], "- %s and put to filename in format: \"%s\".", filtername, option1);

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "gettag%c%s", '\0', option1);
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: From format to format
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_format")))))
	{
		sprintf(filtername, "Change format from");
		sprintf(option1, "%s", gtk_entry_get_text (GTK_ENTRY(lookup_widget(rules,("entry_rules_fromformat")))));
		sprintf(option2, "%s", gtk_entry_get_text (GTK_ENTRY(lookup_widget(rules,("entry_rules_toformat")))));

		sprintf(output[0], "- %s \"%s\" to \"%s\".", filtername, option1, option2);

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "format%c%s%c%s", '\0', option1, '\0', option2);
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Kill leading end ending spaces
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_killspace")))))
	{
		sprintf(filtername, "Kill spaces");
		gtk_label_get(GTK_LABEL(GTK_BIN(lookup_widget(rules, _("option_rules_killspace")))->child),&foo);
		sprintf(option1, "%s", foo);

		sprintf(output[0], "- %s at %s of the filename.", filtername, option1);
		
		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "killspace%c%s", '\0', option1);
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Replace custom strings
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_replace")))))
	{
		sprintf(filtername, "Replace");
		sprintf(option1, "%s", gtk_entry_get_text (GTK_ENTRY(lookup_widget(rules,("entry_rules_replace_from")))));
		sprintf(option2, "%s", gtk_entry_get_text (GTK_ENTRY(lookup_widget(rules,("entry_rules_replace_to")))));

		sprintf(output[0], "- %s \"%s\" by \"%s\".", filtername, option1, option2);
		
		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "replace%c%s%c%s", '\0', option1, '\0', option2);
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Remove parentheses
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_remove")))))
	{
		sprintf(filtername, "Remove");
		gtk_label_get(GTK_LABEL(GTK_BIN(lookup_widget(rules, _("option_rules_remove_leading")))->child),&foo);
		sprintf(option1, "%s", foo);

		sprintf(output[0], "- %s %s parentheses.", filtername, option1);

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "parentheses%c%s%c", '\0', option1, '\0');
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Force-set character case
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_forcecc")))))
	{
		sprintf(filtername, "Force-set");
		gtk_label_get(GTK_LABEL(GTK_BIN(lookup_widget(rules, _("option_rules_forcecc_case")))->child),&foo);
		sprintf(option1, "%s", foo);

		sprintf(output[0], "- %s characters case to %s.", filtername, option1);

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "forcecc%c%s%c", '\0', option1, '\0');
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Delete characters from pos to pos
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_deletechar")))))
	{
		sprintf(filtername, "Delete character");

		sprintf(option1, "%i", gtk_spin_button_get_value_as_int(
									GTK_SPIN_BUTTON(lookup_widget(rules, _("spin_rules_deletechar_from")))));
		sprintf(option2, "%i", gtk_spin_button_get_value_as_int(
									GTK_SPIN_BUTTON(lookup_widget(rules, _("spin_rules_deletechar_to")))));
		
		sprintf(output[0], "- %s %s to character %s.", filtername, option1, option2);

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "deletechar%c%s%c%s", '\0', option1, '\0', option2);
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: First number increase
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_increase")))))
	{
		sprintf(filtername, "Increase");
		sprintf(option1, "%i", gtk_spin_button_get_value_as_int(
									GTK_SPIN_BUTTON(lookup_widget(rules, _("spin_rules_increase_by")))));
		sprintf(output[0], "- %s first number by %s", filtername, option1);

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "increase%c%s%c", '\0', option1, '\0');
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Strip all characters before first digit
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_stripchar")))))
	{
		sprintf(filtername, "Delete all characters before first digit");
		sprintf(output[0], "- %s.", filtername);

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "stripchar%c%c%c%c", '\0', '\0', '\0', '\0');
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: First number twodigit
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_twodigit")))))
	{
		sprintf(filtername, "First number twodigit");
		sprintf(output[0], "- %s.", filtername);

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "twodigit%c%c%c%c", '\0', '\0', '\0', '\0');
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Add space before uppercase letters
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_insertspace")))))
	{
		sprintf(filtername, "Insert a space before every uppercase letter");
		sprintf(output[0], "- %s.", filtername);

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "insertspace%c%c%c%c", '\0', '\0', '\0', '\0');
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
// ADD FILTER: Strip multiple spaces
	if (gtk_toggle_button_get_active
		(GTK_TOGGLE_BUTTON(lookup_widget (rules, _("check_rules_stripspace")))))
	{
		sprintf(filtername, "Strip multiple spaces");
		sprintf(output[0], "- %s.", filtername);

		rowdata=mem_allocate(&clist_rules_data);
		sprintf(rowdata, "stripspace%c%c%c%c", '\0', '\0', '\0', '\0');
		gtk_clist_set_row_data(GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))),
			gtk_clist_append (GTK_CLIST (lookup_widget(rules, _("clist_rules_rules"))), output),
			rowdata);
	}
	free(filtername);
	free(option1);
	free(option2);
}