/* the gmp3 project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/gmp3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include "support.h"
#include "file_to_tag.h"
#include "id3v1.h"
#include "id3v2.3.h"

/*
 ***************************************************************************
 * this will extract infos from filename and put them for preview to a form
 ***************************************************************************
 */
void filename_to_tag_preview(void)
{
	extern GtkWidget *gmp3;
	GtkCList *clist_queue;
	GList *selection;
	gint i=0, u=-1, row;
	
	gchar *trenner[8];
	gchar *ptrenner[8];
	gchar *option[8][2];
	gchar *format = calloc(2000,sizeof(gchar));
	gchar *pformat=format;
	gchar *cfilename = calloc(2000,sizeof(gchar));
	gchar *pcfilename = cfilename;
	gchar *foo = calloc(2000,sizeof(gchar));
	gchar *pfoo = foo;
	gchar *filename;
	
	trenner[0] = calloc(2000,sizeof(gchar));
	ptrenner[0] = trenner[0];
	option[0][0] = calloc(2000,sizeof(gchar));
	option[0][1] = calloc(2000,sizeof(gchar));
	
	clist_queue = GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue")));
	selection = clist_queue->selection;
	
/* First of all clear the current preview */
	gtk_entry_set_text(GTK_ENTRY(lookup_widget (gmp3, _("entry_gmp3_file2tag_previewartist"))), "");
	gtk_entry_set_text(GTK_ENTRY(lookup_widget (gmp3, _("entry_gmp3_file2tag_previewalbum"))), "");
	gtk_entry_set_text(GTK_ENTRY(lookup_widget (gmp3, _("entry_gmp3_file2tag_previewsong"))), "");
	gtk_entry_set_text(GTK_ENTRY(lookup_widget (gmp3, _("entry_gmp3_file2tag_previewtrack"))), "");
	gtk_entry_set_text(GTK_ENTRY(lookup_widget (gmp3, _("entry_gmp3_file2tag_previewyear"))), "");

/* Get filename of first selected row in queue */
	if (selection)
	{
		row = (gint)selection->data;

		gtk_clist_get_text (clist_queue, row, 0, &filename);
		
		sprintf(cfilename, "%s", strrchr(filename,'/')+1);
		*strrchr(cfilename, '.')='\0';

		sprintf(format, "%s", gtk_entry_get_text (GTK_ENTRY(lookup_widget(gmp3,("entry_gmp3_file2tag_file")))));
	}		


/* Save the parts between %-switches in "trenner" and the switches in "options" */
	if(format != NULL)
	{
		for(pformat=format; (*pformat!='\0'); pformat++)
		{
			if(*pformat!='%')
			{
				*ptrenner[i]++=*pformat;
			}
			else
			{
				if(*(++pformat)=='%')
				{
					*ptrenner[i]++=*pformat;
				}
				else
				{
					if(*pformat=='a')
						sprintf(option[i][0], "artist");
					if(*pformat=='b')
						sprintf(option[i][0], "album");
					if(*pformat=='s')
						sprintf(option[i][0], "song");
					if(*pformat=='t')
						sprintf(option[i][0], "track");
					if(*pformat=='y')
						sprintf(option[i][0], "year");
					if(*pformat=='x')
						sprintf(option[i][0], "delete");
					if(i+1>=7) break;
					trenner[++i] = calloc(2000,sizeof(gchar));
					ptrenner[i] = trenner[i];
					option[i][0] = calloc(2000,sizeof(gchar));
					option[i][1] = calloc(2000,sizeof(gchar));
				}
			}
		}
	
		pcfilename=cfilename;
		while(++u<=i)
		{
			if(*option[u][0]=='\0') break;
			ptrenner[u] = trenner[u];
			for(; (*ptrenner[u]!='\0'); pcfilename++)
			{
				if(*pcfilename!=*ptrenner[u]++)
				{
					for(u=0; u<=i; u++)
					{
						free(trenner[u]);
						free(option[u][0]);
						free(option[u][1]);
					}
					free(foo);
					free(cfilename);
					free(format);
					return;
				}
			}
			
			memset(foo, 0, 1000);
 			pfoo=foo;
			for(; (*pcfilename!='\0'); pcfilename++)
			{
				if(*trenner[u+1]=='\0')
				{
					strcpy(foo, pcfilename);
					break;
				}
				if(strncmp(pcfilename, trenner[u+1], strlen(trenner[u+1]))==0)
					break;
				else
					*pfoo++=*pcfilename;
			}
			strcpy(option[u][1], foo);
		}
	}
	for(u=0; u<=i; u++)
	{
		if(*option[u][0]!='\0')
		{
			if(strncmp(option[u][0], "delete", 6))
			{
				sprintf(foo, "entry_gmp3_file2tag_preview%s", option[u][0]);
				gtk_entry_set_text(GTK_ENTRY(lookup_widget (gmp3, foo)), option[u][1]);
			}
		}
		free(trenner[u]);
		free(option[u][0]);
		free(option[u][1]);
	}
	free(foo);
	free(cfilename);
	free(format);
}




/*
 ***************************************************************************
 * this will extract infos from filename and put the to the tag
 ***************************************************************************
 */
void filename_to_tag_proceed(void)
{
	extern GtkWidget *gmp3;
	GtkCList *clist_queue;
	gint i=0, u=-1, row=-1;
	
	gchar *trenner[8];
	gchar *ptrenner[8];
	gchar *option[8][2];
	gchar *cfilename = calloc(2000,sizeof(gchar));
	gchar *pcfilename = cfilename;
	gchar *format = calloc(2000,sizeof(gchar));
	gchar *pformat=format;
	gchar *foo = calloc(2000,sizeof(gchar));
	gchar *pfoo = foo;
	gchar *filename;
	gboolean error=FALSE;
	gchar status[4096];
	gint numrows=-1;

	id3Tag *tag = calloc(1,sizeof(id3Tag));

	clist_queue = GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue")));

	sprintf(format, "%s", gtk_entry_get_text (GTK_ENTRY(lookup_widget(gmp3,("entry_gmp3_file2tag_file")))));
	
	while (gtk_clist_get_row_data (clist_queue, ++numrows));

	while (gtk_clist_get_row_data (clist_queue, ++row))
	{
		trenner[0] = calloc(2000,sizeof(gchar));
		ptrenner[0] = trenner[0];
		option[0][0] = calloc(2000,sizeof(gchar));
		option[0][1] = calloc(2000,sizeof(gchar));
		
		gtk_clist_get_text (clist_queue, row, 0, &filename);
		
		sprintf(status, "Filename to tag: %s", filename);
		gnome_appbar_set_status(GNOME_APPBAR (lookup_widget (gmp3, _("appbar"))), status);
		gnome_appbar_set_progress(GNOME_APPBAR (lookup_widget (gmp3, _("appbar"))), (gfloat)100/numrows*row*0.01);
		while(g_main_iteration(FALSE));
		
		sprintf(cfilename, "%s", strrchr(filename,'/')+1);
		*strrchr(cfilename, '.')='\0';
		i=0;
		u=-1;

/* Save the parts between %-switches in "trenner" and the switches in "options" */
		if(format != NULL)
		{
			for(pformat=format; (*pformat!='\0'); pformat++)
			{
				if(*pformat!='%')
				{
					*ptrenner[i]++=*pformat;
				}
				else
				{
					if(*(++pformat)=='%')
					{
						*ptrenner[i]++=*pformat;
					}
					else
					{
						if(*pformat=='a')
							sprintf(option[i][0], "artist");
						if(*pformat=='b')
							sprintf(option[i][0], "album");
						if(*pformat=='s')
							sprintf(option[i][0], "song");
						if(*pformat=='t')
							sprintf(option[i][0], "track");
						if(*pformat=='y')
							sprintf(option[i][0], "year");
						if(*pformat=='x')
							sprintf(option[i][0], "delete");
						if(i+1>=7) break;
						trenner[++i] = calloc(2000,sizeof(gchar));
						ptrenner[i] = trenner[i];
						option[i][0] = calloc(2000,sizeof(gchar));
						option[i][1] = calloc(2000,sizeof(gchar));
					}
				}
			}
		
			pcfilename=cfilename;
			while(++u<=i)
			{
				error=FALSE;
				
				if(*option[u][0]=='\0') break;
				ptrenner[u] = trenner[u];
				for(; (*ptrenner[u]!='\0'); pcfilename++)
				{
					if(*pcfilename!=*ptrenner[u]++)
					{
						error = TRUE;
						break;
					}
				}
				if(error==TRUE) break;
				
				memset(foo, 0, 1000);
				pfoo=foo;
				for(; (*pcfilename!='\0'); pcfilename++)
				{
					if(*trenner[u+1]=='\0')
					{
						strcpy(foo, pcfilename);
						break;
					}
					if(strncmp(pcfilename, trenner[u+1], strlen(trenner[u+1]))==0)
						break;
					else
						*pfoo++=*pcfilename;
				}
				strcpy(option[u][1], foo);
			}
		}
		
		if(!error)
		{
			id3Tag *v2 = malloc(sizeof(id3Tag));
// get old tag. v2 tag has higher prio, so it will overwrite the v1	
			get_id3v1_tag(tag, filename);
			if(get_id3v2_tag(v2, filename)==0)
			{
				v2->genre = tag->genre;
				free(tag);
				tag = v2;
			}
			else
				free(v2);
			
			for(u=0; u!=i; u++)
			{
				if(strcmp(option[u][0],"artist")==0)
				{
					memset(tag->artist, '\0', 1024);
					strncpy(tag->artist, option[u][1], 1023);
				}
				if(strcmp(option[u][0],"album")==0)
				{
					memset(tag->album, '\0', 1024);
					strncpy(tag->album, option[u][1], 1023);
				}
				if(strcmp(option[u][0],"song")==0)
				{
					memset(tag->title, '\0', 1024);
					strncpy(tag->title, option[u][1], 1023);
				}
				if(strcmp(option[u][0],"year")==0)
				{
					memset(tag->year, '\0', 5);
					strncpy(tag->year, option[u][1], 4);
				}
				if(strcmp(option[u][0],"track")==0)
					tag->track = atoi(option[u][1]);
			}
// And put the changed tag to the file
			set_id3v2_tag(tag, filename);
			set_id3v1_tag(tag, filename);
		}
		u=-1;
		while(++u<=i)
		{
			free(trenner[u]);
			free(option[u][0]);
			free(option[u][1]);
		}
	}
	free(foo);
	free(cfilename);
	free(format);
	free(tag);
}










/*
 ***************************************************************************
 * this will extract infos from the directory name and put them for preview to a form
 ***************************************************************************
 */
void directory_to_tag_preview(void)
{
	extern GtkWidget *gmp3;
	GtkCList *clist_queue;
	GList *selection;
	gint i=0, u=-1, row;
	
	gchar *trenner[8];
	gchar *ptrenner[8];
	gchar *option[8][2];
	gchar *format = calloc(2000,sizeof(gchar));
	gchar *pformat=format;
	gchar *cfilename = calloc(2000,sizeof(gchar));
	gchar *pcfilename = cfilename;
	gchar *foo = calloc(2000,sizeof(gchar));
	gchar *pfoo = foo;
	gchar *filename;
	
	trenner[0] = calloc(2000,sizeof(gchar));
	ptrenner[0] = trenner[0];
	option[0][0] = calloc(2000,sizeof(gchar));
	option[0][1] = calloc(2000,sizeof(gchar));
	
	clist_queue = GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue")));
	selection = clist_queue->selection;
	
/* Get filename of first selected row in queue */
	if (selection)
	{
		row = (gint)selection->data;

		gtk_clist_get_text (clist_queue, row, 0, &filename);
		
		strcpy(cfilename, filename);
		*strrchr(cfilename, '/')='\0';
		sprintf(cfilename, "%s", strrchr(cfilename, '/') + 1);

		sprintf(format, "%s", gtk_entry_get_text (GTK_ENTRY(lookup_widget(gmp3,("entry_gmp3_file2tag_directory")))));
	}		


/* Save the parts between %-switches in "trenner" and the switches in "options" */
	if(format != NULL)
	{
		for(pformat=format; (*pformat!='\0'); pformat++)
		{
			if(*pformat!='%')
			{
				*ptrenner[i]++=*pformat;
			}
			else
			{
				if(*(++pformat)=='%')
				{
					*ptrenner[i]++=*pformat;
				}
				else
				{
					if(*pformat=='a')
						sprintf(option[i][0], "artist");
					if(*pformat=='b')
						sprintf(option[i][0], "album");
					if(*pformat=='s')
						sprintf(option[i][0], "song");
					if(*pformat=='t')
						sprintf(option[i][0], "track");
					if(*pformat=='y')
						sprintf(option[i][0], "year");
					if(*pformat=='x')
						sprintf(option[i][0], "delete");
					if(i+1>=7) break;
					trenner[++i] = calloc(2000,sizeof(gchar));
					ptrenner[i] = trenner[i];
					option[i][0] = calloc(2000,sizeof(gchar));
					option[i][1] = calloc(2000,sizeof(gchar));
				}
			}
		}
	
		pcfilename=cfilename;
		while(++u<=i)
		{
			if(*option[u][0]=='\0') break;
			ptrenner[u] = trenner[u];
			for(; (*ptrenner[u]!='\0'); pcfilename++)
			{
				if(*pcfilename!=*ptrenner[u]++)
				{
					for(u=0; u<=i; u++)
					{
						free(trenner[u]);
						free(option[u][0]);
						free(option[u][1]);
					}
					free(foo);
					free(cfilename);
					free(format);
					return;
				}
			}
			
			memset(foo, 0, 1000);
 			pfoo=foo;
			for(; (*pcfilename!='\0'); pcfilename++)
			{
				if(*trenner[u+1]=='\0')
				{
					strcpy(foo, pcfilename);
					break;
				}
				if(strncmp(pcfilename, trenner[u+1], strlen(trenner[u+1]))==0)
					break;
				else
					*pfoo++=*pcfilename;
			}
			strcpy(option[u][1], foo);
		}
	}
	for(u=0; u<=i; u++)
	{
		if(*option[u][0]!='\0')
		{
			if(strncmp(option[u][0], "delete", 6))
			{
				sprintf(foo, "entry_gmp3_file2tag_preview%s", option[u][0]);
				if(*gtk_entry_get_text(GTK_ENTRY(lookup_widget (gmp3, foo)))=='\0')
					gtk_entry_set_text(GTK_ENTRY(lookup_widget (gmp3, foo)), option[u][1]);
			}
		}
		free(trenner[u]);
		free(option[u][0]);
		free(option[u][1]);
	}
	free(foo);
	free(cfilename);
	free(format);
}








/*
 ***************************************************************************
 * this will extract infos from the directory name and put the to the tag
 ***************************************************************************
 */
void directory_to_tag_proceed(void)
{
	extern GtkWidget *gmp3;
	GtkCList *clist_queue;
	gint i=0, u=-1, row=-1;
	
	gchar *trenner[8];
	gchar *ptrenner[8];
	gchar *option[8][2];
	gchar *cfilename = calloc(2000,sizeof(gchar));
	gchar *pcfilename = cfilename;
	gchar *format = calloc(2000,sizeof(gchar));
	gchar *pformat=format;
	gchar *foo = calloc(2000,sizeof(gchar));
	gchar *pfoo = foo;
	gchar *filename;
	gboolean error=FALSE;
	gchar bar[4096];
	gint numrows=-1;

	id3Tag *tag = calloc(1,sizeof(id3Tag));

	clist_queue = GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue")));

	sprintf(format, "%s", gtk_entry_get_text (GTK_ENTRY(lookup_widget(gmp3,("entry_gmp3_file2tag_directory")))));

	while (gtk_clist_get_row_data (clist_queue, ++numrows));
	
	while ((gtk_clist_get_row_data (clist_queue, ++row)))
	{
		trenner[0] = calloc(2000,sizeof(gchar));
		ptrenner[0] = trenner[0];
		option[0][0] = calloc(2000,sizeof(gchar));
		option[0][1] = calloc(2000,sizeof(gchar));

		gtk_clist_get_text (clist_queue, row, 0, &filename);
		
		sprintf(bar, "Directoryname to tag: %s", filename);
		gnome_appbar_set_status(GNOME_APPBAR (lookup_widget (gmp3, _("appbar"))), bar);
		gnome_appbar_set_progress(GNOME_APPBAR (lookup_widget (gmp3, _("appbar"))), (gfloat)100/numrows*row*0.01);
		while(g_main_iteration(FALSE));
		
		strcpy(cfilename, filename);
		*strrchr(cfilename, '/')='\0';
		sprintf(cfilename, "%s", strrchr(cfilename, '/') + 1);
		i=0;
		u=-1;

/* Save the parts between %-switches in "trenner" and the switches in "options" */
		if(format != NULL)
		{
			for(pformat=format; (*pformat!='\0'); pformat++)
			{
				if(*pformat!='%')
				{
					*ptrenner[i]++=*pformat;
				}
				else
				{
					if(*(++pformat)=='%')
					{
						*ptrenner[i]++=*pformat;
					}
					else
					{
						if(*pformat=='a')
							sprintf(option[i][0], "artist");
						if(*pformat=='b')
							sprintf(option[i][0], "album");
						if(*pformat=='s')
							sprintf(option[i][0], "song");
						if(*pformat=='t')
							sprintf(option[i][0], "track");
						if(*pformat=='y')
							sprintf(option[i][0], "year");
						if(*pformat=='x')
							sprintf(option[i][0], "delete");
						if(i+1>=7) break;
						trenner[++i] = calloc(2000,sizeof(gchar));
						ptrenner[i] = trenner[i];
						option[i][0] = calloc(2000,sizeof(gchar));
						option[i][1] = calloc(2000,sizeof(gchar));
					}
				}
			}
		
			pcfilename=cfilename;
			while(++u<=i)
			{
				error=FALSE;
				
				if(*option[u][0]=='\0') break;
				ptrenner[u] = trenner[u];
				for(; (*ptrenner[u]!='\0'); pcfilename++)
				{
					if(*pcfilename!=*ptrenner[u]++)
					{
						error = TRUE;
						break;
					}
				}
				if(error==TRUE) break;
				
				memset(foo, 0, 1000);
				pfoo=foo;
				for(; (*pcfilename!='\0'); pcfilename++)
				{
					if(*trenner[u+1]=='\0')
					{
						strcpy(foo, pcfilename);
						break;
					}
					if(strncmp(pcfilename, trenner[u+1], strlen(trenner[u+1]))==0)
						break;
					else
						*pfoo++=*pcfilename;
				}
				strcpy(option[u][1], foo);
			}
		}
		
		if(!error)
		{
			id3Tag *v2 = malloc(sizeof(id3Tag));
// get old tag. v2 tag has higher prio, so it will overwrite the v1	
			get_id3v1_tag(tag, filename);
			if(get_id3v2_tag(v2, filename)==0)
			{
				v2->genre = tag->genre;
				free(tag);
				tag = v2;
			}
			else
				free(v2);
			
			for(u=0; u!=i; u++)
			{
				if(strcmp(option[u][0],"artist")==0)
				{
					memset(tag->artist, '\0', 1024);
					strncpy(tag->artist, option[u][1], 1023);
				}
				if(strcmp(option[u][0],"album")==0)
				{
					memset(tag->album, '\0', 1024);
					strncpy(tag->album, option[u][1], 1023);
				}
				if(strcmp(option[u][0],"song")==0)
				{
					memset(tag->title, '\0', 1024);
					strncpy(tag->title, option[u][1], 1023);
				}
				if(strcmp(option[u][0],"year")==0)
				{
					memset(tag->year, '\0', 5);
					strncpy(tag->year, option[u][1], 4);
				}
				if(strcmp(option[u][0],"track")==0)
					tag->track = atoi(option[u][1]);
			}
// And put the changed tag to the file
			set_id3v2_tag(tag, filename);
			set_id3v1_tag(tag, filename);
		}
		u=-1;
		while(++u<=i)
		{
			free(trenner[u]);
			free(option[u][0]);
			free(option[u][1]);
		}
	}
	free(foo);
	free(cfilename);
	free(format);
	free(tag);
}
