/* the gmp3 project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/gmp3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <grp.h>
#include <pwd.h>
#include "callbacks.h"
#include "config.h"
#include "support.h"
#include "filelist_icon.h"
#include "public.h"

/*
* Return 1 is filepathname is a directory, otherwise 0
*/
static int
is_a_dir (char *filepathname)
{
	struct stat pstat;
	stat (filepathname, &pstat);
	return (S_ISDIR (pstat.st_mode));
}



/*
* Print out the given directory to the clist box
*/
void
update_file_iconlist (GnomeIconList *gil, gchar *userdir, gchar *extension)
{
	struct dirent *pdirent = NULL;
	extern Stack clist_files_data;
	DIR *pdir = NULL;
	gchar *output = NULL;
	gchar foo[2048], *temp=NULL;
	gint row;

	gnome_icon_list_clear(gil);
	gnome_icon_list_freeze(gil);
	mem_free(&clist_files_data);
	
	if ((pdir = opendir (userdir)) == NULL)
		return;

	while ((pdirent = readdir (pdir)) != NULL)
	{
		sprintf(foo, "%s", strrchr(pdirent->d_name, '.'));
		if(foo[0]!='\0')
		{
			if (!strcmp (foo, extension)
				&& !is_a_dir(pdirent->d_name))
			{
				output = mem_allocate(&clist_files_data);
				strcpy(output, pdirent->d_name);
				
				temp = g_strconcat(PACKAGE_PIXMAPS_DIR, "/", "gmp3/mp3.xpm", NULL);
				row = gnome_icon_list_append (gil, temp, output);
				free(temp);
				
				gnome_icon_list_set_icon_data(gil, row, output);
			}
		}
	}
	closedir(pdir);
	gnome_icon_list_thaw(gil);
}