/* the gmp3 project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/gmp3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "tag.h"

typedef struct id3v2Tag_s
{
	gboolean unsync;
	gboolean has_extheader;
	gboolean is_experimental;
	gboolean has_footer;
	guint tag_size;
	guint extheader_size;
	gboolean is_update;
	gboolean crc_data_present;
	gboolean restrictions;
	guint flag_bytes;
	guint crc_data_length;
	guchar *crc_data;
	guint restrictions_data_length;
	guchar *restrictions_data;
	guchar *frame_id[32];
	guint frame_datasize[32];
	guchar frame_statusflag[32];
	guchar frame_formatflag[32];
	guchar *frame_data[32];
} id3v2Tag;

extern int get_id3v2_tag(id3Tag *tag, gchar *filename);
extern int set_id3v2_tag(id3Tag *tag, gchar *filename);
extern int del_id3v2_tag(gchar *filename);
