/* the gmp3 project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/gmp3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include "popups.h"
#include "support.h"
#include "gui.h"
#include "public.h"
#include "filelist.h"
#include "id3v1.h"
#include "id3v2.3.h"

void clist_gmp3_queue_rightclicked(gint x, gint y)
{
	extern gint lastclick_x;
	extern gint lastclick_y;
	extern GtkWidget *gmp3;
	GList* node = g_list_first(GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue")))->selection);
	gint row, col;
	gboolean selected=FALSE;

	lastclick_x=x;
	lastclick_y=y;

	gtk_clist_get_selection_info(GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue"))), x, y, &row, &col);
	while (node)
	{
		if (row == (int)node->data) selected=TRUE;
		node = g_list_next(node);
	}
	if(!selected)
	{
		gtk_clist_unselect_all(GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue"))));
		gtk_clist_select_row(GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue"))), row, col);
	}
}



void popup_gmp3_queue_remove(void)
{
	extern GtkWidget *gmp3;
	GList* node = g_list_last(GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue")))->selection);
	gint row=0;
	
	while (node)
	{
		row = (int)node->data;
// if this is the last entry in the clist then clear the clist and free all memory.
		if(row==0 && !gtk_clist_get_row_data(GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue"))),1))
		{
			extern Stack clist_queue_data;

			gtk_clist_clear(GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue"))));
			mem_free(&clist_queue_data);
			break;
		}
		node = g_list_previous(node);
		gtk_clist_remove(GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue"))), row);
	}
}



void popup_gmp3_queue_clear(void)
{
	extern GtkWidget *gmp3;
	extern Stack clist_queue_data;

	mem_free(&clist_queue_data);
	gtk_clist_clear (GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue"))));
	gnome_appbar_set_status(GNOME_APPBAR (lookup_widget (gmp3, _("appbar"))), "List has been cleared.");
}



void popup_gmp3_queue_select(const gchar *status)
{
	extern GtkWidget *gmp3;
	GtkCList *clist_gmp3_queue;
	gchar *foo;
	GList* node = NULL;
	gboolean selected=FALSE;
	gint row=-1;

	clist_gmp3_queue = GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue")));

	if(strncmp(status, "invert", 6)==0)
	{
		while ((foo=gtk_clist_get_row_data (clist_gmp3_queue, ++row)))
		{
			selected=FALSE;
			node = g_list_first(GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_queue")))->selection);
			while (node)
			{
				if (row == (int)node->data) selected=TRUE;
				node = g_list_next(node);
			}
			if(!selected)
				gtk_clist_select_row(clist_gmp3_queue, row, 0);
			else
				gtk_clist_unselect_row(clist_gmp3_queue, row, 0);
		}
		return;
	}

	if(strncmp(status, "id3v1", 5)==0)
	{
		id3Tag *tag = calloc(1,sizeof(id3Tag));
		gchar *filename;
		
		while ((foo = gtk_clist_get_row_data (clist_gmp3_queue, ++row)))
		{
			gtk_clist_get_text(clist_gmp3_queue, row, 0, &filename);
			if(get_id3v1_tag(tag, filename)==0)
				gtk_clist_select_row(clist_gmp3_queue, row, 0);
		}
		free(tag);
		return;
	}

	if(strncmp(status, "id3v2", 5)==0)
	{
		id3Tag *tag = calloc(1,sizeof(id3Tag));
		gchar *filename;
		
		while ((foo = gtk_clist_get_row_data (clist_gmp3_queue, ++row)))
		{
			gtk_clist_get_text(clist_gmp3_queue, row, 0, &filename);
			if(get_id3v2_tag(tag, filename)==0)
				gtk_clist_select_row(clist_gmp3_queue, row, 0);
		}
		free(tag);
		return;
	}

	if(strncmp(status, "notag", 5)==0)
	{
		id3Tag *tag = calloc(1,sizeof(id3Tag));
		gchar *filename;
		
		while ((foo = gtk_clist_get_row_data (clist_gmp3_queue, ++row)))
		{
			gtk_clist_get_text(clist_gmp3_queue, row, 0, &filename);
			if( get_id3v1_tag(tag, filename)!=0
				&& get_id3v2_tag(tag, filename)!=0 )
				gtk_clist_select_row(clist_gmp3_queue, row, 0);
		}
		free(tag);
		return;
	}

	while ((foo=gtk_clist_get_row_data (clist_gmp3_queue, ++row)))
	{
		if(strcmp(foo, status)==0)
			gtk_clist_select_row(clist_gmp3_queue, row, 0);
	}
}







void clist_gmp3_filelist_rightclicked(gint x, gint y)
{
	extern gint lastclick_x;
	extern gint lastclick_y;
	extern GtkWidget *gmp3;
	GList* node = g_list_first(GTK_CLIST (lookup_widget (gmp3, _("clist_gmp3_iconlist")))->selection);
	gint row;
	gboolean selected=FALSE;

	lastclick_x=x;
	lastclick_y=y;

	while (node)
	{
		row = (int)node->data;
		if (row == (int)node->data) selected=TRUE;
		node = node->next;
	}
	if(!selected)
	{
		gnome_icon_list_unselect_all(GNOME_ICON_LIST (lookup_widget (gmp3, _("clist_gmp3_iconlist"))), NULL, NULL);
		gnome_icon_list_select_icon(GNOME_ICON_LIST (lookup_widget (gmp3, _("clist_gmp3_iconlist"))),
			gnome_icon_list_get_icon_at(GNOME_ICON_LIST (lookup_widget (gmp3, _("clist_gmp3_iconlist"))), x, y));
	}
}






void popup_gmp3_filelist_refresh(void)
{
	update_file_list ();
}




void popup_gmp3_filelist_rename_file(void)
{
	extern gint lastclick_x;
	extern gint lastclick_y;
	extern GtkWidget *gmp3;
	extern GtkWidget *popup_rename_file;
	gint icon=-1;

	icon=gnome_icon_list_get_icon_at(GNOME_ICON_LIST (lookup_widget (gmp3, _("clist_gmp3_iconlist"))), lastclick_x, lastclick_y);
	if(icon!=-1)
	{
		popup_rename_file=create_rename_file();
		gtk_entry_set_text(GTK_ENTRY(lookup_widget (popup_rename_file, _("entry_gmp3_rename_file_name"))), 
			(char *)gnome_icon_list_get_icon_data(GNOME_ICON_LIST (lookup_widget (gmp3, _("clist_gmp3_iconlist"))), icon));
		gtk_widget_show(popup_rename_file);
	}
}




void popup_gmp3_filelist_rename_file_ok(void)
{
	extern GtkWidget *popup_rename_file;
	extern GtkWidget *gmp3;
	extern gchar *current_dir;
	extern gint lastclick_x;
	extern gint lastclick_y;
	gchar fileold[4000];
	gchar filenew[4000];
	gint icon=-1;

	icon=gnome_icon_list_get_icon_at(GNOME_ICON_LIST (lookup_widget (gmp3, _("clist_gmp3_iconlist"))), lastclick_x, lastclick_y);
	
	sprintf(fileold, "%s/%s", current_dir,
		(char *)gnome_icon_list_get_icon_data(GNOME_ICON_LIST (lookup_widget (gmp3, _("clist_gmp3_iconlist"))), icon));
	sprintf(filenew, "%s/%s", current_dir,
		gtk_entry_get_text(GTK_ENTRY(lookup_widget (popup_rename_file, _("entry_gmp3_rename_file_name"))))); 
	rename(fileold, filenew);
	gtk_widget_destroy(popup_rename_file);
	update_file_list ();
}









void popup_gmp3_dirtree_rename_directory(void)
{
	extern gint lastclick_x;
	extern gint lastclick_y;
	extern GtkWidget *gmp3;
	extern GtkWidget *popup_rename_directory;
	gint row, col;
	gchar directory[2000];
	GtkCTreeNode *node;

	gtk_clist_get_selection_info(GTK_CLIST (lookup_widget (gmp3, "ctree_gmp3_directories")), lastclick_x, lastclick_y, &row, &col);
	if(row!=-1)
	{
		node = gtk_ctree_node_nth (GTK_CTREE (lookup_widget (gmp3, _("ctree_gmp3_directories"))), row);
		popup_rename_directory=create_rename_directory();
		
		strcpy(directory,
			gtk_ctree_node_get_row_data (GTK_CTREE (lookup_widget (gmp3, _("ctree_gmp3_directories"))), node));
		*strrchr(directory, '/')='\0';
		sprintf(directory, "%s", strrchr(directory, '/') + 1);
		
		gtk_entry_set_text(GTK_ENTRY(lookup_widget (popup_rename_directory, _("entry_gmp3_rename_directory_name"))), 
			(char *)directory);
		gtk_widget_show(popup_rename_directory);
	}
}






void popup_gmp3_dirtree_rename_directory_ok(void)
{
	extern GtkWidget *popup_rename_directory;
	extern GtkWidget *gmp3;
	extern gint lastclick_x;
	extern gint lastclick_y;
	gchar dirold[4000];
	gchar dirnew[4000];
	gchar parentdir[4000];
	extern gchar *current_dir;
	gint row, col;
	gchar *foo;
	GdkPixmap *pm;
	GdkBitmap *mask;
	GtkCTreeNode *node;

	gtk_clist_get_selection_info(GTK_CLIST (lookup_widget (gmp3, "ctree_gmp3_directories")), lastclick_x, lastclick_y, &row, &col);
	
	node = gtk_ctree_node_nth (GTK_CTREE (lookup_widget (gmp3, _("ctree_gmp3_directories"))), row);
	
// determine full parentdir
	strcpy(parentdir,
		gtk_ctree_node_get_row_data (GTK_CTREE (lookup_widget (gmp3, _("ctree_gmp3_directories"))), node));
	*strrchr(parentdir, '/')='\0';
	*strrchr(parentdir, '/')='\0';

// full path old dir
	strcpy(dirold,
		gtk_ctree_node_get_row_data (GTK_CTREE (lookup_widget (gmp3, _("ctree_gmp3_directories"))), node));
	*strrchr(dirold, '/')='\0';
	sprintf(dirold, "%s/%s", parentdir, strrchr(dirold, '/') + 1);

// if a "/" is found in the new filename, don't do anything.
	if(strchr(gtk_entry_get_text(
		GTK_ENTRY(lookup_widget (popup_rename_directory, _("entry_gmp3_rename_directory_name")))), '/')!=NULL)
	{
		gtk_widget_destroy(popup_rename_directory);
		return;
	}
	
// and full path new dir
	sprintf(dirnew, "%s/%s", parentdir,
		gtk_entry_get_text(GTK_ENTRY(lookup_widget (popup_rename_directory, _("entry_gmp3_rename_directory_name"))))); 
		
	gtk_widget_destroy(popup_rename_directory);
	
// if unsuccesful, don't update node info.
	if(rename(dirold, dirnew)!=0)
		return;
	
	sprintf(current_dir, "%s/", dirnew);
	
	gtk_ctree_node_get_pixtext(GTK_CTREE (lookup_widget (gmp3, _("ctree_gmp3_directories"))), node, 0, &foo, NULL, &pm, &mask);
	gtk_ctree_node_set_pixtext(GTK_CTREE (lookup_widget (gmp3, _("ctree_gmp3_directories"))), node, 0, strrchr(dirnew, '/') + 1,
		5, pm, mask);
	sprintf(gtk_ctree_node_get_row_data (GTK_CTREE (lookup_widget (gmp3, _("ctree_gmp3_directories"))), node), "%s/", dirnew);

	gtk_ctree_sort_recursive(GTK_CTREE (lookup_widget (gmp3, _("ctree_gmp3_directories"))), GTK_CTREE_ROW(node)->parent);
}
