/* the gmp3 project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/gmp3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * This file includes often needed functions for stackhandling and for looking up an gtk-widget
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include "public.h"

/*
 * This will init a stack variable
 */
void
mem_init (Stack * memstack)
{
	memstack->count = 0;
}


/*
 * This will allocate space and store the location of this space in the stack variable
 */
gpointer
mem_allocate (Stack * memstack) 
{
	memstack->data[memstack->count] = calloc (2048, sizeof (gchar));
	if(memstack->count+1>=30000)
	{
		printf("Crash! (Sorry, no more memory available.");
		exit(1);
	}
	return (gpointer) memstack->data[memstack->count++];
}



/*
 * This free all the space allocated in the stack variable
 */
void
mem_free (Stack * memstack) 
{
	while(--(memstack->count)>=0)
		free (memstack->data[memstack->count]);
	memstack->count = 0;
}


/*
 * This will store the address of the given pointer in a stack
 */
gpointer
mem_push (Stack * memstack, gpointer pointer) 
{
	memstack->data[memstack->count] = pointer;
	if(memstack->count+1>=30000)
	{
		printf("Crash! (Sorry, no more memory available.");
		exit(1);
	}
	return (gpointer) memstack->data[memstack->count++];
}