/* the gmp3 project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/gmp3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "genre.h"
#include "support.h"
#include "tag.h"
#include "id3v1.h"
#include "id3v2.3.h"
#include "mpgheader.h"

void settag(gchar *filename)
{
	extern GtkWidget *gmp3;
	gchar *foo;
	guint i;
	id3Tag *tag = calloc(1,sizeof(id3Tag));
	id3Tag *v2 = calloc(1,sizeof(id3Tag));
	gchar bar[4096];

	sprintf(bar, "Saving tags: %s", filename);
	gnome_appbar_set_status(GNOME_APPBAR (lookup_widget (gmp3, _("appbar"))), bar);
	while(g_main_iteration(FALSE));
		
// Get old Tag
	memset(tag->artist, '\0', 1024);
	memset(tag->title, '\0', 1024);
	memset(tag->album, '\0', 1024);
	memset(tag->year, '\0', 1024);
	memset(tag->comment, '\0', 1024);
// get the tag to a struct.
	get_id3v1_tag(tag, filename);

// v2 tag has higher prio, so it will overwrite the v1	
	if(get_id3v2_tag(v2, filename)==0)
	{
		v2->genre = tag->genre;
		free(tag);
		tag = v2;
	}
	else
		free(v2);

// And overwrite where user wants to set new fields
	foo=gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_song"))));
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, _("check_gmp3_song")))))
	{
		memset(tag->title, '\0', 1024);
		strncpy(tag->title, foo, strlen(foo));
	}
	foo=gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_artist"))));
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, _("check_gmp3_artist")))))
	{
		memset(tag->artist, '\0', 1024);
		strncpy(tag->artist, foo, strlen(foo));
	}
	foo=gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_album"))));
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, _("check_gmp3_album")))))
	{
		memset(tag->album, '\0', 1024);
		strncpy(tag->album, foo, strlen(foo));
	}
	foo=gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_year"))));
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, _("check_gmp3_year")))))
	{
		memset(tag->year, '\0', 5);
		strncpy(tag->year, foo, strlen(foo));
	}

	foo=gtk_editable_get_chars(GTK_EDITABLE (lookup_widget (gmp3, _("text_gmp3_comment"))), 0,
		gtk_text_get_length(GTK_TEXT (lookup_widget (gmp3, _("text_gmp3_comment")))));
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, _("check_gmp3_comment")))))
	{
		memset(tag->comment, '\0', 1024);
		strncpy(tag->comment, foo, strlen(foo));
	}
	free(foo);

	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, _("check_gmp3_track")))))
		tag->track = atoi(gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_track")))));
	
	foo=gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_genre"))));
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, _("check_gmp3_genre")))))
	{
		for(i=0;i<=147;i++)
		{
			if(strcmp(genre[i], foo)==0)
				tag->genre = i;
		}
	}

// And put the changed tag to the file
	if(access(filename, W_OK)==0)
	{
		set_id3v1_tag(tag, filename);
		set_id3v2_tag(tag, filename);
	}

	free(tag);
	gnome_appbar_set_status(GNOME_APPBAR (lookup_widget (gmp3, _("appbar"))), "Tag succesfully saved!");
}



void updatetag(gchar *filename, gint mode)
{
	extern GtkWidget *gmp3;
	gchar track[4];
	gint mygenre;
	Header *mp3header = malloc(sizeof(Header));
	gchar foo[2000], *foobar=NULL;
	gboolean have_tag = FALSE;
	
	id3Tag *tag = calloc(1,sizeof(id3Tag));
	id3Tag *v2 = malloc(sizeof(id3Tag));
	
	gnome_appbar_set_status(GNOME_APPBAR (lookup_widget (gmp3, _("appbar"))), "Reading tag...");
	if(get_mpgheader(mp3header, filename)==0)
	{
		sprintf(foo, "MPEG V%s, Layer %i\nSample rate: %i\nBitrate: %i\n",
			mp3header->version, mp3header->layer, mp3header->frequency, mp3header->bitrate);
		if(mp3header->seconds-( ((int)mp3header->seconds/60)*60 )<10)
		{
			sprintf(foo, "%sTime: %i:0%i\n", foo,
				(int)mp3header->seconds/60, mp3header->seconds-( ((int)mp3header->seconds/60)*60 ));
		}
		else
		{
			sprintf(foo, "%sTime: %i:%i\n", foo,
				(int)mp3header->seconds/60, mp3header->seconds-( ((int)mp3header->seconds/60)*60 ));
		}
		if(mp3header->copyright)
			sprintf(foo, "%sCopyright: Yes\n", foo);
		else
			sprintf(foo, "%sCopyright: No\n", foo);
		if(mp3header->original)
			sprintf(foo, "%sOriginal/copy: Original\n", foo);
		else
			sprintf(foo, "%sOriginal/copy: Copy\n", foo);
			
		if(get_id3v1_tag(tag, filename)==0)
			sprintf(foo, "%sID3V1 Tag present.\n", foo);
			
		if(get_id3v2_tag(tag, filename)==0)
			sprintf(foo, "%sID3V2 Tag present.\n", foo);
		gtk_label_set_text(GTK_LABEL (lookup_widget (gmp3, _("label_gmp3_mpginfo"))), foo);
	}
	else
	{
		gtk_label_set_text(GTK_LABEL (lookup_widget (gmp3, _("label_gmp3_mpginfo"))), "No valid header found!");
	}
	
// first of all, empty all out
	if(mode==0)
	{
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_artist"))), (char *)"");
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_song"))), (char *)"");
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_album"))), (char *)"");
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_year"))), (char *)"");
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_track"))), (char *)"");
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_genre"))), genre[12]);
		gtk_text_set_point(GTK_TEXT (lookup_widget (gmp3, _("text_gmp3_comment"))), 0);
		gtk_text_forward_delete(GTK_TEXT (lookup_widget (gmp3, _("text_gmp3_comment"))), 
			gtk_text_get_length(GTK_TEXT (lookup_widget (gmp3, _("text_gmp3_comment")))));
	}
	
// get the tag to a struct.
	if(get_id3v1_tag(tag, filename)==0)
		have_tag = TRUE;
// v2 tag has higher prio, so it will overwrite the v1	
	if(get_id3v2_tag(v2, filename)==0)
	{
		have_tag = TRUE;
		v2->genre = tag->genre;
		free(tag);
		tag = v2;
	}
	else
		free(v2);
		
	if(!have_tag)
	{
		free(tag);
		free(mp3header);
		gnome_appbar_set_status(GNOME_APPBAR (lookup_widget (gmp3, _("appbar"))), "");
		return;
	}

// and put the tag to the form (mode 0)
// or delete where tag does not match the already selected tags (mode 1).
	if(mode==0)
	{
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_artist"))), tag->artist);
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_song"))), tag->title);
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_album"))), tag->album);
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_year"))), tag->year);
		sprintf(track, "%u", (guint)tag->track);
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_track"))), track);
		gtk_text_insert(GTK_TEXT (lookup_widget (gmp3, _("text_gmp3_comment"))), NULL, NULL, NULL, tag->comment, -1);
		if((tag->genre&127)>125)
			mygenre = 12;
		else
			mygenre = tag->genre;
		
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_genre"))), genre[mygenre]);
	}
	else
	{
		if(strcmp(gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_artist")))), tag->artist))
			gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_artist"))), "");
		if(strcmp(gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_song")))), tag->title))
			gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_song"))), "");
		if(strcmp(gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_album")))), tag->album))
			gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_album"))), "");
		if(strcmp(gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_year")))), tag->year))
			gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_year"))), "");
		sprintf(track, "%u", (guint)tag->track);
		if(strcmp(gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_track")))), track))
			gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_track"))), "");
		
		foobar = gtk_editable_get_chars(GTK_EDITABLE (lookup_widget (gmp3, _("text_gmp3_comment"))), 0,
			gtk_text_get_length(GTK_TEXT (lookup_widget (gmp3, _("text_gmp3_comment")))));
		if(strcmp(foobar, tag->comment))
		{
			gtk_text_set_point(GTK_TEXT (lookup_widget (gmp3, _("text_gmp3_comment"))), 0);
			gtk_text_forward_delete(GTK_TEXT (lookup_widget (gmp3, _("text_gmp3_comment"))), 
				gtk_text_get_length(GTK_TEXT (lookup_widget (gmp3, _("text_gmp3_comment")))));
		}
		free(foobar);
		
		if((tag->genre&127)>125)
			mygenre = 12;
		else
			mygenre = tag->genre;
		
		if(strcmp(genre[mygenre], gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_genre"))))))
			gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, _("entry_gmp3_genre"))), "");
	}

	free(tag);
	free(mp3header);
	gnome_appbar_set_status(GNOME_APPBAR (lookup_widget (gmp3, _("appbar"))), "");
	return;
}



void deltag(gchar *filename)
{
	extern GtkWidget *gmp3;
	gchar bar[4096];
	
	sprintf(bar, "Deleting tags: %s", filename);
	gnome_appbar_set_status(GNOME_APPBAR (lookup_widget (gmp3, _("appbar"))), bar);
	while(g_main_iteration(FALSE));

	if(access(filename, W_OK)==0)
	{
		del_id3v1_tag(filename);
		del_id3v2_tag(filename);
	}

	gnome_appbar_set_status(GNOME_APPBAR (lookup_widget (gmp3, _("appbar"))), "Tags were succesfully deleted.");
}